package cn.ibizlab.core.sample.service.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.Map;
import java.util.HashSet;
import java.util.HashMap;
import java.util.Collection;
import java.util.Objects;
import java.util.Optional;
import java.math.BigInteger;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cglib.beans.BeanCopier;
import org.springframework.stereotype.Service;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.Pageable;
import org.springframework.util.ObjectUtils;
import org.springframework.beans.factory.annotation.Value;
import cn.ibizlab.util.errors.BadRequestAlertException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Lazy;
import cn.ibizlab.core.sample.domain.IBIZSample0006;
import cn.ibizlab.core.sample.filter.IBIZSample0006SearchContext;
import cn.ibizlab.core.sample.service.IIBIZSample0006Service;

import cn.ibizlab.util.helper.CachedBeanCopier;
import cn.ibizlab.util.helper.DEFieldCacheMap;
import com.alibaba.fastjson.JSONObject;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import cn.ibizlab.core.sample.mapper.IBIZSample0006Mapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.core.conditions.Wrapper;
import org.springframework.util.StringUtils;

/**
 * 实体[嵌套流程（主）] 服务对象接口实现
 */
@Slf4j
@Service("IBIZSample0006ServiceImpl")
public class IBIZSample0006ServiceImpl extends ServiceImpl<IBIZSample0006Mapper, IBIZSample0006> implements IIBIZSample0006Service {

    @Autowired
    @Lazy
    protected cn.ibizlab.core.sample.service.IIBIZSample0007Service ibizsample0007Service;

    protected int batchSize = 500;

    @Override
    @Transactional
    public boolean create(IBIZSample0006 et) {
        if(!this.retBool(this.baseMapper.insert(et))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getIbizsample0006id()), et);
        return true;
    }

    @Override
    @Transactional
    public void createBatch(List<IBIZSample0006> list) {
        this.saveBatch(list, batchSize);
    }

    @Override
    @Transactional
    public boolean update(IBIZSample0006 et) {
        if(!update(et, (Wrapper) et.getUpdateWrapper(true).eq("ibizsample0006id", et.getIbizsample0006id()))) {
            return false;
        }
        CachedBeanCopier.copy(get(et.getIbizsample0006id()), et);
        return true;
    }

    @Override
    @Transactional
    public void updateBatch(List<IBIZSample0006> list) {
        updateBatchById(list, batchSize);
    }

    @Override
    @Transactional
    public boolean remove(String key) {
        ibizsample0007Service.resetByIbizsample0006id(key);
        boolean result = removeById(key);
        return result ;
    }

    @Override
    @Transactional
    public void removeBatch(Collection<String> idList) {
        ibizsample0007Service.resetByIbizsample0006id(idList);
        removeByIds(idList);
    }

    @Override
    @Transactional
    public IBIZSample0006 get(String key) {
        IBIZSample0006 et = getById(key);
        if (et == null) {
            throw new BadRequestAlertException("数据不存在", this.getClass().getSimpleName(), key);
        }
        else {
        }
        return et;
    }

    @Override
    public IBIZSample0006 getDraft(IBIZSample0006 et) {
        return et;
    }

    @Override
    public boolean checkKey(IBIZSample0006 et) {
        return (!ObjectUtils.isEmpty(et.getIbizsample0006id())) && (!Objects.isNull(this.getById(et.getIbizsample0006id())));
    }
    @Override
    @Transactional
    public boolean save(IBIZSample0006 et) {
        if(!saveOrUpdate(et)) {
            return false;
        }
        return true;
    }

    @Override
    @Transactional
    public boolean saveOrUpdate(IBIZSample0006 et) {
        if (null == et) {
            return false;
        } else {
            return checkKey(et) ? getProxyService().update(et) : getProxyService().create(et);
        }
    }

    @Override
    @Transactional
    public boolean saveBatch(Collection<IBIZSample0006> list) {
        List<IBIZSample0006> create = new ArrayList<>();
        List<IBIZSample0006> update = new ArrayList<>();
        for (IBIZSample0006 et : list) {
            if (ObjectUtils.isEmpty(et.getIbizsample0006id()) || ObjectUtils.isEmpty(getById(et.getIbizsample0006id()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
        return true;
    }

    @Override
    @Transactional
    public void saveBatch(List<IBIZSample0006> list) {
        List<IBIZSample0006> create = new ArrayList<>();
        List<IBIZSample0006> update = new ArrayList<>();
        for (IBIZSample0006 et : list) {
            if (ObjectUtils.isEmpty(et.getIbizsample0006id()) || ObjectUtils.isEmpty(getById(et.getIbizsample0006id()))) {
                create.add(et);
            } else {
                update.add(et);
            }
        }
        if (create.size() > 0) {
            getProxyService().createBatch(create);
        }
        if (update.size() > 0) {
            getProxyService().updateBatch(update);
        }
    }



    /**
     * 查询集合 DEFAULT
     */
    @Override
    public Page<IBIZSample0006> searchDefault(IBIZSample0006SearchContext context) {
        if(!StringUtils.isEmpty(context.getSrfWF())){
            Map<String,Map<String,Object>> businesskeys = fillWFTaskContext2(context);
            com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBIZSample0006> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
            fillWFParam(pages,businesskeys);
            return new PageImpl<IBIZSample0006>(pages.getRecords(), context.getPageable(), pages.getTotal());
        }else{
            fillWFTaskContext(context);
            com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBIZSample0006> pages=baseMapper.searchDefault(context.getPages(),context,context.getSelectCond());
            return new PageImpl<IBIZSample0006>(pages.getRecords(), context.getPageable(), pages.getTotal());
        }
    }


    @Autowired
    private cn.ibizlab.util.client.IBZWFFeignClient ibzwfFeignClient;


    /**
     * 查询统一工作流待办
     * @param context
     */
    private Map<String,Map<String,Object>> fillWFTaskContext2(IBIZSample0006SearchContext context){
        Map<String, Map<String, Object>> businessKeys = null;
        if(!StringUtils.isEmpty(context.getSrfWF())){
            businessKeys= ibzwfFeignClient.getMyTask("demosys", "", "ibizsample0006s");
            if(businessKeys.size()>0){
                context.getSelectCond().in("ibizsample0006id",businessKeys.keySet());
            }
            else{
                context.getSelectCond().apply("1<>1");
            }
        }
        return businessKeys;
    }

    /**
     * 填充工作流参数
     * @param pages
     * @param businesskeys
     */
    private void fillWFParam(com.baomidou.mybatisplus.extension.plugins.pagination.Page<IBIZSample0006> pages, Map<String, Map<String, Object>> businesskeys) {
        if (!ObjectUtils.isEmpty(businesskeys)) {
            for (IBIZSample0006 entity : pages.getRecords()) {
                Object id = entity.getIbizsample0006id();
                if (!ObjectUtils.isEmpty(id) && businesskeys.containsKey(id)) {
                    Map<String, Object> params = businesskeys.get(id);
                    for (Map.Entry<String, Object> entry : params.entrySet()) {
                        entity.set(entry.getKey(), entry.getValue());
                    }
                }
            }
        }
    }

    private void fillWFTaskContext(IBIZSample0006SearchContext context){
        if(!StringUtils.isEmpty(context.getUserTaskId()) && !StringUtils.isEmpty(context.getProcessDefinitionKey())){
            List<String> businessKeys= ibzwfFeignClient.getbusinesskeysByUserId("demosys", cn.ibizlab.util.security.AuthenticationUser.getAuthenticationUser().getUserid(),"ibizsample0006s",context.getProcessDefinitionKey(),context.getUserTaskId());
            if(businessKeys.size()>0){
                context.getSelectCond().in("ibizsample0006id",businessKeys);
            }
            else{
                context.getSelectCond().apply("1<>1");
            }
        }
    }





    @Override
    public List<JSONObject> select(String sql, Map param){
        return this.baseMapper.selectBySQL(sql,param);
    }

    @Override
    @Transactional
    public boolean execute(String sql , Map param){
        if (sql == null || sql.isEmpty()) {
            return false;
        }
        if (sql.toLowerCase().trim().startsWith("insert")) {
            return this.baseMapper.insertBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("update")) {
            return this.baseMapper.updateBySQL(sql,param);
        }
        if (sql.toLowerCase().trim().startsWith("delete")) {
            return this.baseMapper.deleteBySQL(sql,param);
        }
        log.warn("暂未支持的SQL语法");
        return true;
    }

    @Override
    public List<IBIZSample0006> getIbizsample0006ByIds(List<String> ids) {
         return this.listByIds(ids);
    }

    @Override
    public List<IBIZSample0006> getIbizsample0006ByEntities(List<IBIZSample0006> entities) {
        List ids =new ArrayList();
        for(IBIZSample0006 entity : entities){
            Serializable id=entity.getIbizsample0006id();
            if(!ObjectUtils.isEmpty(id)){
                ids.add(id);
            }
        }
        if(ids.size()>0) {
            return this.listByIds(ids);
        }
        else {
            return entities;
        }
    }




    public IIBIZSample0006Service getProxyService() {
        return cn.ibizlab.util.security.SpringContextHolder.getBean(this.getClass());
    }
}



